#include"doll.hpp"




Arm::
Arm(const std::u16string&  prefix, int  base_length, Arm*  companion_):
companion(companion_)
{
  upper = new Node(prefix+u"上腕");
  lower = new Node(prefix+u"前腕");
  hand  = new Node(prefix+u"手");

  upper->append(*lower);
  lower->append(*hand);
}


void
Arm::
link()
{
  lower = upper->children.back();
  hand  = lower->children.back();
}


void
Arm::
sync()
{
}




Leg::
Leg(const std::u16string&  prefix, int  base_length, Leg*  companion_):
companion(companion_)
{
  upper = new Node(prefix+u"大腿");
  lower = new Node(prefix+u"脛");
  foot  = new Node(prefix+u"足");

  upper->append(*lower);
  lower->append(*foot);

  lower->source.offset.z = upper->z_width;
  foot->source.offset.z  = lower->z_width;
}


void
Leg::
link()
{
  lower = upper->children.back();
  foot  = lower->children.back();
}


void
Leg::
sync()
{
}




Doll::
Doll():
left_arm(u"左",0,&right_arm),
right_arm(u"右",0,&left_arm),
left_leg(u"左",0,&right_leg),
right_leg(u"右",0,&left_leg)
{
  head    = new Node(u"頭部");
  breast  = new Node(u"胸部");
  waist   = new Node(u"腰部");
  scrotum = new Node(u"陰嚢");
  penis   = new Node(u"陰茎");


  waist->source.offset.reset(120,120,120);

  waist->append(*scrotum);

  waist->append( *left_leg.upper);
  waist->append(*right_leg.upper);

  waist->append(*breast);
  breast->append(*head);


  scrotum->append(*penis);

  breast->append( *left_arm.upper);
  breast->append(*right_arm.upper);
}




void
Doll::
write(Stream&  s) const
{
  waist->write(s);
}


void
Doll::
read(Stream&  s)
{
  waist = new Node;

  waist->read(s);


  auto  it = waist->children.begin();

  scrotum         = *it++;
  left_leg.upper  = *it++;
  right_leg.upper = *it++;
  breast          = *it  ;

  penis = scrotum->children.front();


  it = breast->children.begin();

  head            = *it++;
  left_arm.upper  = *it++;
  right_arm.upper = *it  ;

  left_leg.link() ;
  right_leg.link();
  left_arm.link() ;
  right_arm.link();
}




