#ifndef DOLL_HPP_INCLUDED
#define DOLL_HPP_INCLUDED


#include"node.hpp"




struct
Arm
{
  Node*  upper;
  Node*  lower;
  Node*   hand;

  Arm*  companion;

  Arm(const std::u16string&  prefix, int  base_length=40, Arm*  companion_=nullptr);

  void  link();
  void  sync();

};


struct
Leg
{
  Node*  upper;
  Node*  lower;
  Node*   foot;

  Leg*  companion;

  Leg(const std::u16string&  prefix, int  base_length=40, Leg*  companion_=nullptr);

  void  link();
  void  sync();

};


struct
Doll
{
  Node*     head;
  Node*   breast;
  Node*    waist;
  Node*  scrotum;
  Node*    penis;

  Arm   left_arm;
  Arm  right_arm;

  Leg   left_leg;
  Leg  right_leg;

  Doll();


  void  write(Stream&  s) const;
  void   read(Stream&  s)      ;

};


#endif




