#ifndef FIELD_HPP_INCLUDED
#define FIELD_HPP_INCLUDED


#include"doll.hpp"


struct
Field
{
  static constexpr int  size=240;

  static constexpr RenderingParameter  get_rendparam(){return RenderingParameter(size,size,size);}

  static constexpr int   width = 160;
  static constexpr int  height = 160;

  std::u16string  name;

  Point3D  center_point;
  Point3D  cursor_point;
  Point3D    view_point;
  Point3D    base_point;


  Doll  doll;

  std::list<Node*>  root_nodes;

  PixelMap16  thumbnail;

   Field();
  ~Field();

  void    put();
  void  unput();

  void  transfer() const;

  bool  process(const Controller&  ctrl);

  static void  draw(Drawer&  dr, void*  data, int  item_index, int  x, int  y);

};


struct
FieldRenderer
{
  static void  push(const Polygon3D&  pg);

  static void  prepare();

  static void  clear();

  static void  draw(Drawer&  dr);

};


#endif




