#include"field.hpp"




namespace{


std::vector<Polygon3D::RenderingData>
buffer;


bool
compare(const Polygon3D::RenderingData&  a, const Polygon3D::RenderingData&  b)
{
  return(a.priority_number < b.priority_number);
}


}




void
FieldRenderer::
push(const Polygon3D&  pg)
{
  buffer.push_back(pg);
}


void
FieldRenderer::
clear()
{
  buffer.clear();
}


void
FieldRenderer::
prepare()
{
  std::stable_sort(buffer.begin(),buffer.end(),compare);
}


void
FieldRenderer::
draw(Drawer&  dr)
{
    for(auto&  dat: buffer)
    {
      dat.draw(dr);
    }
}





