#ifndef NODE_HPP_INCLUDED
#define NODE_HPP_INCLUDED


#include"object.hpp"
#include"stream.hpp"


struct
Node
{
  int  number;

  std::u16string  name;

  const Node*  parent;

  int  x_width;
  int  y_width;
  int  z_width;

  std::vector<Polygon3D>  polygons;

  struct Parameter: public RotationParameter{
    Point3D  offset;

  } source, applied;


  std::list<Node*>  children;

   Node(const std::u16string&  name=u"NONAME");
  ~Node(                                     );


  void  delete_children();
  void  remove_children();

  void  append(Node&  child);

  void  remake();

  void  write_as_root();
  void  write();

  void  render_center(Drawer&  dr) const;
  void  render_lines(Drawer&  dr, uint8_t  l=255) const;

  static void  write(Stream&  s, const Parameter&  param);
  static void   read(Stream&  s,       Parameter&  param);

  void  write(Stream&  s) const;
  void   read(Stream&  s)      ;

  void  print() const;

};


#endif




