#include"stream.hpp"
#include"field.hpp"
#include"widget.d/flexmenu.hpp"
#include"widget.d/lettermenu.hpp"
#include"widget.d/frame.hpp"
#include"widget.d/textboard.hpp"
#include"video.d/video.hpp"




Controller
ctrl;


namespace{


enum class Task
{
  choose_part,
  choose_item,

  makefield,

} task;


int
display_timer;


std::u16string
display_message;


Field*
current_field;


Node*
current_node;


std::vector<Node*>
entry_nodes;


/*
FlexMenu
top_menu({
u"キューブを作成",
u"すべてを保存",
});


LetterMenu
letter_menu;


FlexMenu  field_menu(8,10,Field::width,Field::height,Field::draw,field_table);
FlexMenu  field_menu2(8,10,Field::width,Field::height,Field::draw,field_table);
*/


Frame  main_frame;


FlexMenu
part_menu;


enum class
Op
{
  resize,
  rotate,

  move_offset,
  move_center,

};


FlexMenu
op_menu({
u"サイズ変更",
u"回転",
u"基点を移動",
u"中心点を移動",
});


/*
Frame    topmenu_frame;

Frame   fieldmenu_frame;
Frame   fieldmenu2_frame;
*/

bool
modified;


const char*  const
filename = "__save.dat";


void
save_fields_all()
{
  FileStream  f(fopen(filename,"wb"));

  current_field->doll.write(f);

//    for(auto&  hp: field_table)
    {
//      hp.save(f);
    }


  display_timer = 32;

  display_message = u"SAVED";
}


void
load_fields()
{
  auto  f = fopen(filename,"rb");

    if(f)
    {
      display_timer = 40;

      FileStream  fs(f);

auto&  p = current_field->root_nodes.front();
delete p;
current_field->doll.read(fs);
       p =current_field->doll.waist;


//      auto  ver = fs.get();

//      auto  sz = fs.get();

/*
        if(sz == Cube::size)
        {
          int  n = fs.get_be16();

          display_message = u"読み込みました";
        }

      else
        {
          display_message = u"サイズが違います";
        }
*/
    }
}


/*
void
choose_topmenuitem()
{
    switch(top_menu.process(ctrl))
    {
      case(FlexMenu::Action::decide):
          switch(top_menu.get_item_index())
          {
            case(0):
              task = Task::choose_field;
              break;
            case(1):
                for(auto&  hp: field_table)
                {
                }


              display_timer = 20;
              display_message = u"REFRESHED";
              break;
            case(2):
              save_fields_all();
              break;
          }
        break;
    }
}
*/


/*
void
modify_colorelement()
{
  auto&  ent = *static_cast<ColorEntry*>(colorelement_menu.get_data());

  int  rgb[] = {to_r4(ent.pixel),
                to_g4(ent.pixel),
                to_b4(ent.pixel)};

  int&  v = rgb[colorelement_menu.get_item_index()];

    switch(colorelement_menu.process(ctrl))
    {
      case(FlexMenu::Action::decide):
      case(FlexMenu::Action::cancel):
        task = Task::choose_color;

        proc_i = color_menu.get_item_index();
        colorelement_menu.set_cursor(false,false);
        break;
      case(FlexMenu::Action::left):
          if(v)
          {
            --v;
          }
        break;
      case(FlexMenu::Action::right):
          if(v < 15)
          {
            ++v;
          }
        break;
    }


  ent.pixel = to_pixel16(rgb[0],rgb[1],rgb[2]);
}


void
choose_color()
{
    switch(color_menu.process(ctrl))
    {
      case(FlexMenu::Action::decide):
        task = Task::modify_colorelement;

        current_color = &current_field->palette_.entries[color_menu.get_item_index()];

        colorelement_menu.set_data(current_color);

        colorelement_menu.set_cursor(true,true);
        break;
      case(FlexMenu::Action::cancel):
        task = Task::choose_field;

        current_field->update();
        break;
      case(FlexMenu::Action::right):
        task = Task::choose_mkhpmenuitem;

        color_menu.set_cursor(false,true);
        mkhp_menu.set_cursor(true,true);
        break;
      case(FlexMenu::Action::up):
      case(FlexMenu::Action::down):
        current_color = &current_field->palette_.entries[color_menu.get_item_index()];

        colorelement_menu.set_data(current_color);
        break;
      case(FlexMenu::Action::change):
        task = Task::choose_field_for_paste;
        break;
    }
}


void
choose_field()
{
    switch(field_menu.process(ctrl))
    {
      case(FlexMenu::Action::decide):
        task = Task::choose_color;
        break;
      case(FlexMenu::Action::cancel):
        task = Task::choose_topmenuitem;
        break;
      case(FlexMenu::Action::start):
        task = Task::make_field_name;

        current_field = &field_table[field_menu.get_item_index()];

        letter_menu.reset_buffer(current_field->name);
        break;
    }
}


void
make_field_name()
{
    switch(letter_menu.process(ctrl))
    {
      case(LetterMenu::Action::finish):
        task = Task::choose_field;

        current_field->name = letter_menu.get_buffer();
        break;
    }
}
*/





void
choose_part()
{
    switch(part_menu.process(ctrl))
    {
      case(FlexMenu::Action::decide):
      case(FlexMenu::Action::right):
        task = Task::choose_item;
        op_menu.set_cursor(true,true);
        break;
    }


  current_node = entry_nodes[part_menu.get_item_index()];
}


void
choose_item()
{
    switch(op_menu.process(ctrl))
    {
      case(FlexMenu::Action::decide):
        task = Task::makefield;
        break;
      case(FlexMenu::Action::cancel):
      case(FlexMenu::Action::left):
        task = Task::choose_part;
        op_menu.set_cursor(false,false);
        break;
    }
}


void
resize()
{
  constexpr int  v = 4;

  auto&  nd = *current_node;

    if(ctrl.test_pressing(Key::shift_flag))
    {
           if(ctrl.test_pressing(Key::up_flag  )){nd.z_width -= v;  nd.remake();}
      else if(ctrl.test_pressing(Key::down_flag)){nd.z_width += v;  nd.remake();}
    }

  else
    {
           if(ctrl.test_pressing(Key::up_flag   )){nd.y_width -= v;  nd.remake();}
      else if(ctrl.test_pressing(Key::down_flag )){nd.y_width += v;  nd.remake();}
      else if(ctrl.test_pressing(Key::left_flag )){nd.x_width -= v;  nd.remake();}
      else if(ctrl.test_pressing(Key::right_flag)){nd.x_width += v;  nd.remake();}
    }
}


void
rotate()
{
  constexpr int  v = 4;

  auto&  nd = *current_node;

    if(ctrl.test_pressing(Key::shift_flag))
    {
           if(ctrl.test_pressing(Key::up_flag  )){nd.source.z_degree -= v;}
      else if(ctrl.test_pressing(Key::down_flag)){nd.source.z_degree += v;}
    }

  else
    if(ctrl.test_pressing(Key::start_flag))
    {
      current_node->source.x_degree = 0;
      current_node->source.y_degree = 0;
      current_node->source.z_degree = 0;
    }

  else
    {
           if(ctrl.test_pressing(Key::up_flag    )){nd.source.y_degree -= v;}
      else if(ctrl.test_pressing(Key::down_flag  )){nd.source.y_degree += v;}
      else if(ctrl.test_pressing(Key::left_flag  )){nd.source.x_degree -= v;}
      else if(ctrl.test_pressing(Key::right_flag)){nd.source.x_degree += v;}
    }
}


void
move_point(Point3D&  pt)
{
  constexpr int  v = 4;

    if(ctrl.test_pressing(Key::shift_flag))
    {
           if(ctrl.test_pressing(Key::up_flag  )){pt.z -= v;}
      else if(ctrl.test_pressing(Key::down_flag)){pt.z += v;}
    }

  else
    {
           if(ctrl.test_pressing(Key::up_flag   )){pt.y -= v;}
      else if(ctrl.test_pressing(Key::down_flag )){pt.y += v;}
      else if(ctrl.test_pressing(Key::left_flag )){pt.x -= v;}
      else if(ctrl.test_pressing(Key::right_flag)){pt.x += v;}
    }
}


void
makefield()
{
    if(ctrl.test_pressing(Key::p_flag) ||
       ctrl.test_pressing(Key::n_flag))
    {
      task = Task::choose_item;
    }

  else
    {
        switch((Op)op_menu.get_item_index())
        {
          case(Op::resize):            resize();break;
          case(Op::rotate):            rotate();break;
          case(Op::move_offset):  move_point(current_node->source.offset);break;
          case(Op::move_center):  move_point(current_node->source.center);break;

          default:
            break;
        }


      modified = true;
    }
}


void
draw_entry_node(Drawer&  dr, void*  data, int  item_index, int  x, int  y)
{
  dr.draw_unicode(entry_nodes[item_index]->name.data(),0,x+4,y+4);
}


void
draw_status(Drawer&  dr)
{
  auto&  nd = *current_node;

  int  y = 0;

  const auto&  off = nd.source.offset;
  const auto&  cen = nd.source.center;

    dr.draw_formatted(0xFFFFFFFF,0,y,"deg %3d %3d %3d",nd.source.x_degree,nd.source.y_degree,nd.source.z_degree);  y += font_size;
    dr.draw_formatted(0xFFFFFFFF,0,y,"wid %3d %3d %3d",nd.x_width,nd.y_width,nd.z_width        );  y += font_size;
    dr.draw_formatted(0xFFFFFFFF,0,y,"off %3d %3d %3d",off.x,off.y,off.z        );  y += font_size;
    dr.draw_formatted(0xFFFFFFFF,0,y,"cen %3d %3d %3d",cen.x,cen.y,cen.z        );  y += font_size;
}


}


void
process(video::Device*  video_device)
{
  static uint32_t  last = 0;

  auto  now = SDL_GetTicks();

    if(now >= last+120)
    {
      last = now;

        switch(task)
        {
          case(Task::choose_part): choose_part();   break;
          case(Task::choose_item): choose_item();   break;
          case(Task::makefield     ): makefield();       break;
        }
    }


  video_device->lock();

  auto  dr = video_device->get_drawer();

    switch(task)
    {
      case(Task::choose_part):
      case(Task::choose_item):
      case(Task::makefield):
        main_frame.draw(dr);

          if(modified)
          {
            current_field->transfer();
            FieldRenderer::prepare();

            modified = false;
          }


//        current_field->doll.waist->render_lines(dr);

        FieldRenderer::draw(dr);

current_node->render_center(dr);

          if(task == Task::makefield)
          {
            dr.draw_rect(0xFFFFFFFF,0,0,Field::get_rendparam().width,Field::get_rendparam().height);
          }


        draw_status(dr);
        break;
    }


    if(display_timer)
    {
      --display_timer;

      dr.fill_rect(                          0xFFFFFFFF,0,480-font_h-8,font_w*(display_message.size()+1)+8,font_h+8);
      dr.draw_unicode(display_message.data(),0x00000000,4,480-font_h-4                                             );
    }


  video_device->unlock();

  ctrl.clear();
}




void
initialize()
{
//  task = Task::choose_topmenuitem;
  task = Task::choose_part;

/*
  top_menu.set_cursor(true,true);
  field_menu.set_cursor(true,true);
  field_menu2.set_cursor(true,true);

    topmenu_frame.relative_point.set(0,0);
   fieldmenu_frame.relative_point.set(0,0);
   fieldmenu2_frame.relative_point.set(0,0);

   fieldmenu_frame.reset(u"キューブを作成",{&field_menu},16);
   fieldmenu2_frame.reset(u"サムネイルを貼る",{&field_menu2},16);
*/


  current_field = new Field;

  modified = true;

  load_fields();

  auto&  doll = current_field->doll;

  current_node = doll.waist;

  entry_nodes.emplace_back(doll.waist);
  entry_nodes.emplace_back(doll.head);
  entry_nodes.emplace_back(doll.breast);
  entry_nodes.emplace_back(doll.left_arm.upper);
  entry_nodes.emplace_back(doll.left_arm.lower);
  entry_nodes.emplace_back(doll.left_arm.hand);
  entry_nodes.emplace_back(doll.right_arm.upper);
  entry_nodes.emplace_back(doll.right_arm.lower);
  entry_nodes.emplace_back(doll.right_arm.hand);
  entry_nodes.emplace_back(doll.scrotum);
  entry_nodes.emplace_back(doll.penis);
  entry_nodes.emplace_back(doll.left_leg.upper);
  entry_nodes.emplace_back(doll.left_leg.lower);
  entry_nodes.emplace_back(doll.left_leg.foot);
  entry_nodes.emplace_back(doll.right_leg.upper);
  entry_nodes.emplace_back(doll.right_leg.lower);
  entry_nodes.emplace_back(doll.right_leg.foot);

  part_menu.reset(entry_nodes.size(),1,font_w*6,font_h+8,draw_entry_node);


  part_menu.set_cursor(true,true);

  main_frame.relative_point.set(Field::get_rendparam().width,0);
  main_frame.reset(u"",{&part_menu,&op_menu},16);
}



void
finalize()
{
  save_fields_all();
}




